#++--++
#--++--
define easy_type::profile::firewall::iptables(
  Hash    $ports,
  Boolean $manage_service,
) {

  unless defined(Package['iptables']) {
    package {'iptables':
      ensure => 'present',
    }
  }

  $defaults = {
    ensure => 'present',
    action => 'accept',
    proto  => 'tcp'
  }

  ensure_resources('firewall', $ports, $defaults)

  if $manage_service {
    service { 'iptables':
        ensure    => true,
        enable    => true,
        hasstatus => true,
    }
  }
}
