#++--++
#--++--
define easy_type::profile::groups_and_users(
  String[1] $calling_class,
) {
  $users          = lookup("${calling_class}::users", Hash)
  $user_defaults  = lookup("${calling_class}::user_defaults", Hash, 'first', { 'ensure' => 'present'})
  $groups         = lookup("${calling_class}::groups", Hash)
  $group_defaults = lookup("${calling_class}::group_defaults", Hash, 'first', { 'ensure' => 'present'})

  if $groups.size > 0 {
    $groups_list = $groups.keys
    echo {"Ensure Group(s) ${groups_list.join(',')}":
      withpath => false,
    }
  }

  if $users.size > 0 {
    $users_list = $users.keys
    echo {"Ensure User(s) ${users_list.join(',')}":
      withpath => false,
    }
  }
  #
  # If a password is provided, us it. If not generate a 
  # password that is not easy guesable from the outside.
  # Advise is to specify a strong password in the hiera data.
  #
  $users.each |$user, $settings| {
    if $settings['password'] {
      $full_settings = $settings.merge({'password' => pw_hash($settings['password'], 'SHA-512', regsubst($::macaddress,':','','G'))})
    } else {
      $full_settings = $settings.merge({'password' => pw_hash(regsubst($::macaddress,':','','G'), 'SHA-512', regsubst($::macaddress,':','','G'))})
    }
  }
  ensure_resources('user', $users, $user_defaults)
  ensure_resources('group', $groups, $group_defaults)
}
